com.saxonica.validate

## Class SchemaElementTest

- java.lang.Object
- - net.sf.saxon.pattern.NodeTest
  - - com.saxonica.validate.SchemaElementTest

- All Implemented Interfaces:
    Serializable, SchemaNodeTest, ItemType

      public class SchemaElementTest
      extends NodeTest
      implements SchemaNodeTest

  A NodeTest of the form schema-element(element-name)
  Since:
    9.3
  Author:
    Michael H. Kay
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SchemaElementTest(ElementDecl element)` Constructor

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object other)`
    `SchemaType` | `getContentType()` Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes).
    `double` | `getDefaultPriority()` Determine the default priority of this node test when used on its own as a Pattern
    `ElementDecl` | `getElementDeclaration()` Get the element declaration
    `int` | `getHeadFingerprint()` Get the fingerprint of the head of the substitution group
    `int` | `getNodeKindMask()` Get a mask indicating which kinds of nodes this NodeTest can match.
    `int` | `getPrimitiveType()` Determine the types of nodes to which this pattern applies.
    `IntSet` | `getRequiredNodeNames()` Get the set of node names allowed by this NodeTest.
    `int` | `hashCode()` Returns a hash code value for the object.
    `boolean` | `isNillable()` Determine whether nilled nodes can match this node test
    `boolean` | `isNillable(int fingerprint)` Determine if nilled nodes named N can match this node test
    `boolean` | `matches(int nodeKind, NodeName name, int annotation)` Test whether this node test is satisfied by a given node.
    `boolean` | `matches(NodeInfo node)` Test whether this node test is satisfied by a given node.
    `boolean` | `matches(TinyTree tree, int nodeNr)` Test whether this node test is satisfied by a given node on a TinyTree.
    `static boolean` | `matchesAnnotation(SchemaType required, SchemaType actual)` Determine whether the type annotation of an element or attribute instances matches the required type of the element or attribute declaration named in a schema-element() or schema-attribute() test
    `String` | `toString()`
    `void` | `visitNamedSchemaComponents(SchemaComponentVisitor visitor)` Visit all the schema components used in this ItemType definition

    - ### Methods inherited from class net.sf.saxon.pattern.NodeTest

      `getAtomizedItemType, getFingerprint, getPrimitiveItemType, getSuperType, isAtomicType, isAtomizable, isPlainType, matches, matchesItem`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### SchemaElementTest

          public SchemaElementTest(ElementDecl element)

      Constructor
      Parameters:
        `element` - The element declaration of the named element

  - ### Method Detail

    - #### getElementDeclaration

          public ElementDecl getElementDeclaration()

      Get the element declaration
      Returns:
        the element declaration that this schema-element relates to (the head of the substitution group)

    - #### matches

          public boolean matches(int nodeKind,
                        NodeName name,
                        int annotation)

      Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.
      Specified by:
        `matches` in class `NodeTest`
      Parameters:
        `nodeKind` - The kind of node to be matched
        `name` - identifies the expanded name of the node to be matched. The value should be null for a node with no name.
        `annotation` - The actual content type of the node
      Returns:
        true if the node matches this node tst

    - #### matches

          public boolean matches(TinyTree tree,
                        int nodeNr)

      Test whether this node test is satisfied by a given node on a TinyTree. The node must be a document, element, text, comment, or processing instruction node. This method is provided so that when navigating a TinyTree a node can be rejected without actually instantiating a NodeInfo object.
      Overrides:
        `matches` in class `NodeTest`
      Parameters:
        `tree` - the TinyTree containing the node
        `nodeNr` - the number of the node within the TinyTree
      Returns:
        true if the node matches the NodeTest, otherwise false

    - #### matches

          public boolean matches(NodeInfo node)

      Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.
      Overrides:
        `matches` in class `NodeTest`
      Parameters:
        `node` - the node to be matched
      Returns:
        true if the node test is satisfied by the supplied node, false otherwise

    - #### matchesAnnotation

          public static boolean matchesAnnotation(SchemaType required,
                                  SchemaType actual)

      Determine whether the type annotation of an element or attribute instances matches the required type of the element or attribute declaration named in a schema-element() or schema-attribute() test
      Parameters:
        `required` - the required type of the declaration named in the schema-element() or schema-attribute test
        `actual` - the actual type annotation of the instance
      Returns:
        true if there is a match, false otherwise

    - #### getDefaultPriority

          public final double getDefaultPriority()

      Determine the default priority of this node test when used on its own as a Pattern
      Specified by:
        `getDefaultPriority` in interface `ItemType`
      Returns:
        the default priority

    - #### getPrimitiveType

          public int getPrimitiveType()

      Determine the types of nodes to which this pattern applies. Used for optimisation. For patterns that match nodes of several types, return Type.NODE
      Specified by:
        `getPrimitiveType` in interface `ItemType`
      Overrides:
        `getPrimitiveType` in class `NodeTest`
      Returns:
        the type of node matched by this pattern. e.g. Type.ELEMENT or Type.TEXT

    - #### getNodeKindMask

          public int getNodeKindMask()

      Get a mask indicating which kinds of nodes this NodeTest can match. This is a combination of bits: Type.ELEMENT for element nodes, Type.TEXT for text nodes, and so on.
      Overrides:
        `getNodeKindMask` in class `NodeTest`
      Returns:
        a combination of bits: 1<

    - #### getRequiredNodeNames

          public IntSet getRequiredNodeNames()

      Get the set of node names allowed by this NodeTest. This is returned as a set of Integer fingerprints. A null value indicates that all names are permitted (i.e. that there are no constraints on the node name. The default implementation returns null.
      Overrides:
        `getRequiredNodeNames` in class `NodeTest`
      Returns:
        the set of integer fingerprints of the node names that this node test can match.

    - #### getContentType

          public SchemaType getContentType()

      Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes). Return AnyType if there are no restrictions. The default implementation returns AnyType.
      Overrides:
        `getContentType` in class `NodeTest`
      Returns:
        the type annotation that all nodes matching this NodeTest must satisfy

    - #### isNillable

          public boolean isNillable()

      Determine whether nilled nodes can match this node test
      Overrides:
        `isNillable` in class `NodeTest`
      Returns:
        true if nilled nodes can match this node test

    - #### isNillable

          public boolean isNillable(int fingerprint)

      Determine if nilled nodes named N can match this node test
      Parameters:
        `fingerprint` - the element name
      Returns:
        true if nilled nodes with the given name can match the node test

    - #### getHeadFingerprint

          public int getHeadFingerprint()

      Get the fingerprint of the head of the substitution group
      Returns:
        the fingerprint of the head of the substitution group

    - #### visitNamedSchemaComponents

          public void visitNamedSchemaComponents(SchemaComponentVisitor visitor)
                                          throws XPathException

      Visit all the schema components used in this ItemType definition
      Specified by:
        `visitNamedSchemaComponents` in interface `ItemType`
      Overrides:
        `visitNamedSchemaComponents` in class `NodeTest`
      Parameters:
        `visitor` - the visitor class to be called when each component is visited
      Throws:
        `XPathException` - if an error occurs

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### hashCode

          public int hashCode()

      Returns a hash code value for the object.
      Overrides:
        `hashCode` in class `Object`

    - #### equals

          public boolean equals(Object other)

      Overrides:
        `equals` in class `Object`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.